VERSION 4.00
Begin VB.Form frmStore 
   Caption         =   "OLE Storage"
   ClientHeight    =   4230
   ClientLeft      =   3795
   ClientTop       =   1215
   ClientWidth     =   2985
   Height          =   4830
   Icon            =   "Store.frx":0000
   Left            =   3735
   LinkTopic       =   "Form1"
   ScaleHeight     =   4230
   ScaleWidth      =   2985
   Top             =   675
   Width           =   3105
   Begin MSComDlg.CommonDialog dlgFile 
      Left            =   120
      Top             =   2280
      _Version        =   65536
      _ExtentX        =   847
      _ExtentY        =   847
      _StockProps     =   0
      Filter          =   "OLE storage files|*.ole"
      FilterIndex     =   1
   End
   Begin VB.OLE oleObjects 
      BorderStyle     =   0  'None
      Height          =   1575
      Index           =   0
      Left            =   0
      SizeMode        =   3  'Zoom
      TabIndex        =   0
      Top             =   0
      Width           =   3015
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      NegotiatePosition=   1  'Left
      Begin VB.Menu mnuOpen 
         Caption         =   "&Open"
      End
      Begin VB.Menu mnuSave 
         Caption         =   "&Save"
         Enabled         =   0   'False
      End
      Begin VB.Menu mnuSaveAs 
         Caption         =   "Save &As"
      End
      Begin VB.Menu mnuSep1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuObject 
      Caption         =   "&Object"
      NegotiatePosition=   1  'Left
      Begin VB.Menu mnuNew 
         Caption         =   "&New"
      End
   End
End
Attribute VB_Name = "frmStore"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Private mstrFileName As String
Private mIndex As Integer

Public Sub OpenFile(strFileName As String)
    ' If the file name if valid, open it.
    If Len(strFileName) Or Len(Dir(strFileName)) Then
        mstrFileName = strFileName
        ' Get a file number.
        iFileNum = FreeFile()
        ' Open a file to read.
        Open mstrFileName For Binary As iFileNum
        ' Update the form caption.
        Me.Caption = mstrFileName
        ' Enable the Save menu.
        mnuSave.Enabled = True
    Else
        ' Do nothing.
        Exit Sub
    End If
    ' Clear the existing OLE control array.
    For Each oleControl In oleObjects
        ' Keep the control with mIndex = 0.
        If oleControl.Index Then
            Unload oleControl
        End If
    Next oleControl
    ' Turn on error handling.
    On Error GoTo cmdLoad_Err
    ' Repeat until an error indicating you've reached
    ' the last object in the file, which causes an error.
    Do
        ' Load an object into the control.
        oleObjects(Index).ReadFromFile iFileNum
        ' Increment the count.
        Index = Index + 1
        ' Create another control in the control array.
        Load oleObjects(Index)
        ' Make the object visible
        oleObjects(Index).Visible = True
        ' Reposition each object.
        oleObjects(Index).TOP = oleObjects(Index - 1).TOP _
            + oleObjects(Index - 1).Height
    Loop
cmdLoad_Err:
    If Err = 31037 Then
        ' Unload the last control since it's empty.
        ' Keep the control with mIndex = 0.
        If Index Then Unload oleObjects(Index)
        ' Update the display.
        Me.Refresh
        ' Close the file
        Close iFileNum
        ' Update the number of objects.
        mIndex = Index
        Exit Sub
    Else
        MsgBox "An unhandled error occured: " & _
        Err & Error
    End If
End Sub

Private Sub mnuExit_Click()
    End
End Sub

Private Sub mnuNew_Click()
    ' If this isn't the first object, add
    ' a new control to the control array.
    If mIndex <> 0 Then
        Load oleObjects(mIndex)
        ' Position the object
        oleObjects(mIndex).TOP = oleObjects(mIndex - 1).TOP _
            + oleObjects(mIndex - 1).Height
        ' Make it visible.
        oleObjects(mIndex).Visible = True
    End If
    ' Display the insert OLE object dialog box.
    oleObjects(mIndex).InsertObjDlg
    ' Increment the object count.
    mIndex = mIndex + 1
End Sub

Private Sub mnuOpen_Click()
    ' Get a file name.
    dlgFile.ShowOpen
    OpenFile dlgFile.filename
End Sub

Private Sub mnuSave_Click()
    ' Save the file.
    If SaveToFile(mstrFileName) = False Then
        MsgBox "Could not save the file."
    End If
End Sub

Function SaveToFile(strFileName As String) As Boolean
    iFileNum = FreeFile()
    ' Trap error in case the file name
    ' isn't valid.
    On Error Resume Next
    Open dlgFile.filename For Binary As iFileNum
    If Err Then
        MsgBox "Invalid file name"
        ' Return false.
        SaveToFile = False
        Exit Function
    End If
    ' Save the object in each OLE control
    ' in the oleObjects control array.
    For Each oleControl In oleObjects
        oleControl.SaveToFile iFileNum
    Next oleControl
    ' Close the file.
    Close iFileNum
    ' Return true.
    SaveToFile = True
End Function


Private Sub mnuSaveAs_Click()
    ' Get a file number.
    iFileNum = FreeFile()
    ' Get a file name.
    dlgFile.ShowSave
    ' Save the file.
    If SaveToFile(dlgFile.filename) Then
        ' Update the form caption and module file name.
        mstrFileName = dlgFile.filename
        Me.Caption = mstrFileName
        ' Enable the Save menu choice
        mnuSave.Enabled = True
    End If
End Sub

